// MorphDlg.cpp : implementation file
//

#include "stdafx.h"

#include "Morph.h"
#include "MorphDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMorphDlg dialog

CMorphDlg::CMorphDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMorphDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMorphDlg)
	m_nBrowseVertexAll = 0;
	m_dVertexX = 0.0;
	m_dVertexY = 0.0;
	m_dVertexZ = 0.0;
	m_NormalCount = 0;
	m_dNormalX = 0.0;
	m_dNormalZ = 0.0;
	m_dNormalY = 0.0;
	m_VertexCount = 0;
	m_SimplexCount = 0;
	m_nCurNormal = 0;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_iModel = NULL;
	m_iCurObject = NULL;
	m_iMesh = NULL;
	m_iVertexIterator = NULL;
	m_iSimplexIterator = NULL;
	m_iMeshEx = NULL;
	m_iFrameEx = NULL;
	m_iView = NULL;
	m_iDraw = NULL;

	m_VertexCount = 0;
	m_CurVertex = 0;
	m_VertexHead = 0;
	m_VertexTail = 0;
	m_SimplexCount = 0;
	m_CurSimplex = 0;
	m_SimplexHead = 0;
	m_SimplexTail = 0;
	m_NormalCount = 1;
	m_dNormalLength = 1.0;
	m_curCorner = 0;
	m_nNormal = 0;
	m_nSelectionMode = -1;
	m_bShading = FALSE;
}

void CMorphDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMorphDlg)
	DDX_Control(pDX, IDC_KERNELCADCTRL1, m_kernelCAD);
	DDX_Radio(pDX, IDC_RB_BROWSE_VERTEX_ALL, m_nBrowseVertexAll);
	DDX_Text(pDX, IDC_EDIT_VERTEX_X, m_dVertexX);
	DDX_Text(pDX, IDC_EDIT_VERTEX_Y, m_dVertexY);
	DDX_Text(pDX, IDC_EDIT_VERTEX_Z, m_dVertexZ);
	DDX_Text(pDX, IDC_EDIT_NORMAL_COUNT, m_NormalCount);
	DDX_Text(pDX, IDC_EDIT_NORMAL_X, m_dNormalX);
	DDX_Text(pDX, IDC_EDIT_NORMAL_Z, m_dNormalZ);
	DDX_Text(pDX, IDC_EDIT_NORMAL_Y, m_dNormalY);
	DDX_Text(pDX, IDC_EDIT_VERTEX_COUNT, m_VertexCount);
	DDX_Text(pDX, IDC_EDIT_SIMPL_COUNT, m_SimplexCount);
	DDX_Text(pDX, IDC_EDIT_CUR_NORMAL, m_nCurNormal);
	DDX_Check(pDX, IDC_SHADING, m_bShading);
	DDX_Control(pDX, IDC_SPIN_NORMAL_COUNT, m_spinNormalCount);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMorphDlg, CDialog)
	//{{AFX_MSG_MAP(CMorphDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_BN_CLICKED(IDC_BUT_NEXT_VERT, OnNextVertex)
	ON_BN_CLICKED(IDC_BUT_PREV_VERT, OnPrevVertex)
	ON_BN_CLICKED(IDC_BUT_NEXT_SIMPL, OnNextSimplex)
	ON_BN_CLICKED(IDC_BUT_PREV_SIMPL, OnPrevSimplex)
	ON_BN_CLICKED(IDC_BUTT_VERTEX_MODIFY, OnVertexModify)
	ON_BN_CLICKED(IDC_BUTT_NORMAL_MODIFY, OnNormalModify)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_CUR_NORMAL, OnDeltaposCurNormal)
	ON_EN_KILLFOCUS(IDC_EDIT_CUR_NORMAL, OnKillfocusEditCurNormal)
	ON_BN_CLICKED(IDC_RADIO_MESH, OnRenderMesh)
	ON_BN_CLICKED(IDC_RADIO_SURFACE, OnRenderSurface)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_CUR_OBJ, OnChangeCurObject)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveas)
	ON_COMMAND(IDC_OPEN, OnFileOpen)
	ON_WM_DESTROY()
	ON_COMMAND(ID_SIMPL_DELETE, OnSimplexDelete)
	ON_COMMAND(ID_SIMPL_DIVIDE, OnSimplexDivide)
	ON_BN_CLICKED(IDC_RB_BROWSE_VERTEX_ALL, OnBrowseVertexAll)
	ON_BN_CLICKED(IDC_RB_BROWSE_VERTEX_SIMPL, OnBrowseVertexSimplex)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPIN_NORMAL_COUNT, OnDeltaPosNormalCount)
	ON_COMMAND(ID_VERTEX_DEVETE, OnVertexDelete)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HELP, &CMorphDlg::OnHelp)
	ON_BN_CLICKED(IDC_BUTT_SELECT_SIMPLEX, &CMorphDlg::OnPickSimplex)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_0, &CMorphDlg::OnSimplexGoToNeighbour0)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_1, &CMorphDlg::OnSimplexGoToNeighbour1)
	ON_BN_CLICKED(IDC_BUT_SIMPL_NEIGHBOUR_2, &CMorphDlg::OnSimplexGoToNeighbour2)
	ON_BN_CLICKED(IDC_BUT_STAR_PREV, &CMorphDlg::OnPrevStarSimplex)
	ON_BN_CLICKED(IDC_BUT_STAR_NEXT, &CMorphDlg::OnNextStarSimplex)
	ON_BN_CLICKED(IDC_SHADING, &CMorphDlg::OnShading)
END_MESSAGE_MAP()

BEGIN_EVENTSINK_MAP(CMorphDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CMorphDlg)
	ON_EVENT(CMorphDlg, IDC_KERNELCADCTRL1, 12 /* ClientDraw */, OnClientDraw, VTS_NONE)
	ON_EVENT(CMorphDlg, IDC_KERNELCADCTRL1, 11 /* CurrentObjectChanged */, OnCurrentObjectChanged, VTS_UNKNOWN)
	//}}AFX_EVENTSINK_MAP
	ON_EVENT(CMorphDlg, IDC_KERNELCADCTRL1, DISPID_MOUSEDOWN, CMorphDlg::OnMouseDown, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
END_EVENTSINK_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMorphDlg message handlers

BOOL CMorphDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// By default m_kernelCAD does not load any model
	// (ModelPath property is empty)
	// Create a simple thetrahedral by building its mesh
	CreateDefault();

	UpdateModelInfo();

	SetupView();

	CButton* pRadioMesh = (CButton*)GetDlgItem(IDC_RADIO_MESH);
		
	pRadioMesh->SetCheck(1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMorphDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMorphDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// By default the application does not load any model
// ModelPath property is set to empty string in resources
// Construct dynamically simplest mesh consisting of four
// triangles, forming thetrahedral. See documentation for more details
//
void CMorphDlg::CreateDefault()
{
	m_iModel = (IModel*)m_kernelCAD.GetModel();

	// Create new mesh section
	m_iCurObject = CreateDefaultObject();

	// Get array of objects of the model
	IArray* iArray = NULL;
	m_iModel->QueryInterface(IID_IArray, (void**)&iArray);

	// Remove all current
	iArray->RemoveAll();

	// Add new one
	iArray->Add(m_iCurObject);

	m_iCurObject->SetName("Thetrahedral");

	// Crete geometry by creating the mesh directly
	IMeshTopolT* iMeshTopol = NULL;

	m_iCurObject->QueryInterface(IID_IMeshTopolT, (void**)&iMeshTopol);

	// Create a thetrahedral consisting of four joined triangles
	INT_PTR posnResult = 0;

	for( int i=0; i<4; i++)
		iMeshTopol->AddVertex(&posnResult);// Will add a new vertex in the end of the 
	// vertex list (empty now). The vertex will have all zero 
	// coordinates by default

	// Modify coordinates of the vertices

	// Get access to the vertex list 
	IMeshT* iMesh = NULL;

	m_iCurObject->QueryInterface(IID_IMeshT, (void**)&iMesh);

	IIteratorT* iVertexIterator = NULL;
	
	iMesh->GetVertexIterator(&iVertexIterator);

	IMeshModsT* iMeshMods = NULL;

	m_iCurObject->QueryInterface(IID_IMeshModsT, (void**)&iMeshMods);

	INT_PTR posVtx[4];	//Positions of corver vertexes

	// Get position of the first vertex
	INT_PTR posVertex = NULL;
	
	iVertexIterator->GetHeadPosition(&posVertex);

	posVtx[0] = posVertex;
	// Leave the first one all zero coordinates

	iVertexIterator->GetNext( &posVertex);// Move to the next
	posVtx[1] = posVertex;
	iMeshMods->SetVertexCoord( posVertex, 1, 0, 0 ); // On X axis

	iVertexIterator->GetNext( &posVertex);// Move to the next
	iMeshMods->SetVertexCoord( posVertex, 0, 1, 0 ); // On Y axis
	posVtx[2] = posVertex;

	iVertexIterator->GetNext( &posVertex);
	iMeshMods->SetVertexCoord( posVertex, 0, 0, 1 ); 
	posVtx[3] = posVertex;

	// Build four triangles on them

	// Vertexes should be listed in CCW order, while looking
	// from the outside of the object:
	iMeshTopol->AddSimplex( posVtx[0], posVtx[2], posVtx[1], 0.0);// Set crease 
	// angle to zero to make all edges sharp. The component will take
	// care of normals

	iMeshTopol->AddSimplex( posVtx[0], posVtx[3], posVtx[2], 0.0);
	iMeshTopol->AddSimplex( posVtx[0], posVtx[1], posVtx[3], 0.0);
	iMeshTopol->AddSimplex( posVtx[1], posVtx[2], posVtx[3], 0.0);

	// Show local frame 
	ISection2* iSection2 = NULL;
	m_iCurObject->QueryInterface(IID_ISection2, (void**)&iSection2);
	iSection2->SetFrameVisible(VARIANT_TRUE);
	iSection2->Release();

	// This application needs a current object
	// It is done automatically during a model load
	// Do it here manually for the dynamically constructed object
	IModel2* iModel2 = NULL;
	m_iModel->QueryInterface(IID_IModel2, (void**)&iModel2);

	iModel2->SetCurrentObject(m_iCurObject);

	// m_kernelCAD::UpdateSurface() does above for parametric 
	// (3DS and SOR) surfaces and does nothing for Mesh Objects
	UpdateDisplay();

	RELEASE(iModel2)
	RELEASE(iArray)
	RELEASE(iMeshTopol)
	RELEASE(iMesh)
	RELEASE(iVertexIterator)
	RELEASE(iMeshMods)
}


ISection* CMorphDlg::CreateDefaultObject()
{
	LPCLASSFACTORY pClf; 
    HRESULT hr;

	// Use COM API call to Create Class Factory ( generic obejct constructor )
	// for Model class
	//
    if( (hr = ::CoGetClassObject(
									CLSID_DIObjGenerator, 
									CLSCTX_INPROC_SERVER,
									NULL, IID_IClassFactory, 
									(void **) &pClf) ) 
								!= NOERROR) 
	{
        TRACE("unable to find CLSID -- error = %x\n", hr);
        return NULL;
    }
 
	IDIObjGenerator* pIObjGenerator = NULL;

	// Use the factory to create an object of Model class
    if( pClf->CreateInstance(NULL, IID_IDIObjGenerator, (void**)&pIObjGenerator) != S_OK )
		return NULL;

	ISection* pISect = NULL;

	pIObjGenerator->Create( eObjTypeMeshSection, (IUnknown**)&pISect);

	pIObjGenerator->Release();

    pClf->Release();

	return pISect;
}


void CMorphDlg::UpdateModelInfo()
{
	RELEASE(m_iModel)	// Release the surrent one

	m_iModel = (IModel*)m_kernelCAD.GetModel();

	IModel2* iModel2 = NULL;
	m_iModel->QueryInterface(IID_IModel2, (void**)&iModel2);

	RELEASE(m_iCurObject)

	iModel2->GetCurrentObject(&m_iCurObject);

	char cType[30];

	// SOR sections do not have mesh
	m_iCurObject->GetSectionType(cType);

	if( strcmp(cType, "SORSection" ) == 0 )
	{
		AfxMessageBox("The loaded model is not suitable for Morph sample");

		m_iCurObject = NULL;
		// Set all like on the start. 
		m_kernelCAD.SetModelPath("");
		// Can look for another object, but keep it simple.
		CreateDefault();

		UpdateModelInfo();

		return;
	}

	UpdateObjectInfo();	

	iModel2->Release();
}


void CMorphDlg::SetupView()
{
	// Enable Client draw event. Otherwise OnClientDraw() will not be called
	m_kernelCAD.RequestClientDraw(true);

	// Get IView for future mode manipulations
	m_iView = (IView*)m_kernelCAD.GetView();

	m_iView->QueryInterface(IID_IDraw, (void**)&m_iDraw);

	// Enable highlighting the current object
	// In surface (not wire frame) mode
	IView2* iView2 = NULL;
	m_iView->QueryInterface(IID_IView2, (void**)&iView2);

	iView2->Enable((int)eHighLightSurface, true);

	iView2->Release();
}


void CMorphDlg::UpdateDisplay()
{
	m_kernelCAD.Invalidate();
	m_kernelCAD.UpdateWindow();
}


void CMorphDlg::UpdateObjectInfo()
{
	if( m_iCurObject != NULL )	// Any object selected?
	{
		// Check old ones released
		RELEASE(m_iFrameEx)
		RELEASE(m_iMesh)
		RELEASE(m_iMeshEx)
		RELEASE(m_iVertexIterator)
		RELEASE(m_iSimplexIterator)

		m_iCurObject->QueryInterface(IID_IFrameEx, (void**)&m_iFrameEx);

		m_iCurObject->QueryInterface(IID_IMeshT, (void**)&m_iMesh);

		if( !m_iMesh )
			return;		// Most likely wrong model is loaded with current object which is not a mesh section

		// Get iterator for list of vertexes:
		m_iMesh->GetVertexIterator(&m_iVertexIterator);

		m_iVertexIterator->GetCount(&m_VertexCount);

		m_iVertexIterator->GetHeadPosition(&m_VertexHead);
		m_iVertexIterator->GetTailPosition(&m_VertexTail);

		// Simplexes:
		m_iMesh->GetSimplexIterator(&m_iSimplexIterator);
		
		UpdatePositions();

		if( m_nBrowseVertexAll == 0 )
		{
			// Case browse all vertexes independently of the current simplex
			m_CurVertex = m_VertexHead;
		}
		else
		{
			SetCurrentVertex(m_curCorner);
		}

		UpdateVertexInfo();

		CalcModelSize();

		m_iMesh->QueryInterface(IID_IMeshExT, (void**)&m_iMeshEx);

		// Generate incidency information. Otherwise ISimplexEx_KCT. IEdge_KC and IVertexEx_KCT will not be available
		m_iMeshEx->Upgrade();

		UpdateNormalInfo();
	}

	UpdatePage();
}


void CMorphDlg::UpdatePositions()
{
	m_iSimplexIterator->GetCount(&m_SimplexCount);
			
	if( m_SimplexCount > 0 )
	{
		m_iSimplexIterator->GetHeadPosition(&m_SimplexHead);
		m_iSimplexIterator->GetTailPosition(&m_SimplexTail);
		m_CurSimplex = m_SimplexHead;
	}
	else
	{
		m_SimplexHead = 0;
		m_SimplexTail = 0;
		m_CurSimplex = 0;
	}
}

void CMorphDlg::SetCurrentVertex(int i)
{
	i = ( i<3 ? i : 0);

	INT_PTR v[3];

	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	m_CurVertex = v[i];
}


void CMorphDlg::UpdateVertexInfo()
{
	if( m_CurVertex == 0 )
		return;

	// Get the current vertex coordinates
	// Expressed in local frame of the object. 
	// to make sure geometry of the object is not changed when the object 
	// is being moved
	m_iMesh->GetVertexCoord(m_CurVertex, &m_dVertexX, &m_dVertexY, &m_dVertexZ );

	// The same vertex in global coordinates. (For IDraw in OnClienDraw() )
	m_vtxGlob = GetVertexGlob(m_CurVertex);

	if( m_nBrowseVertexAll == 1 )
	{
		ISimplexT* iSimplex = NULL;
		
		m_iMeshEx->GetSimplex(m_CurSimplex, &iSimplex);

		// Find out which normal belongs to the current simplex
		int nCorner = FindCorner(m_CurVertex);	

		if( nCorner < 0 )	// Did not find the corner?
		{
			nCorner = 0;
			// Case the current vertex does not belong to the
			// current simplex anymore
			// Change the current vertex to vertex 0 of the 
			// current simplex
			iSimplex->GetVertexPosition( 0, &m_CurVertex );

			// Have to do above staff again
			m_iMesh->GetVertexCoord(m_CurVertex, &m_dVertexX, &m_dVertexY, &m_dVertexZ );

			m_vtxGlob = GetVertexGlob(m_CurVertex);
		}
		
		iSimplex->GetNormalIndex(nCorner, &m_nNormal);

		iSimplex->Release();
	}

	UpdateNormalInfo();

	UpdateVertexGroup();

	UpdateDisplay();
}


void CMorphDlg::CalcModelSize()
{
	// Get estimation of the model size to draw normals 
	// of comparable size
	IMetricsT* iMetrics = NULL;

	m_iModel->QueryInterface(IID_IMetricsT, (void**)&iMetrics);

	// Two opposite corners of the minimal box containing whole model:
	DIPoint min;
	DIPoint max;

	iMetrics->GetDimensions(&min, &max);

	//get max 
	double dModelSize = -1;
	for(int i=0; i<3; i++)
	{
		if(max.x[i]-min.x[i]>dModelSize)
			dModelSize = max.x[i]-min.x[i];
	}

	m_dNormalLength = 0.4*dModelSize;

	iMetrics->Release();
}


DIPoint CMorphDlg::GetVertexGlob(INT_PTR vertex)
{
	DIPoint pt;

	m_iMesh->GetVertexCoord(vertex, pt.x, pt.x+1, pt.x+2 );

	// GetVertexCoord returns pt expresed in locall coordinate axes
	m_iFrameEx->ToGlobal(&pt);

	return pt;
}


// For the case of browsing inside the simplex. 
// Which corner of the current simplex is the current vertex?
int CMorphDlg::FindCorner(INT_PTR vertex)
{
	INT_PTR v[3];

	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	for(int i=0; i<3; i++)
	{
		if( v[i] == vertex )
			return i;
	}

	return -1;	// Did not find
}


void CMorphDlg::UpdateNormalInfo()
{
	if( m_CurVertex == 0 )
		return;	

	if( m_iMeshEx == NULL )
		return;

	// Note: IMeshT.GetNormal() returns only the first normal
	// Which is the only normal when the vertex is a regular one
	// (inside a smooth piece of surface).
	// When the vertex is at an edge or a corner it has several normals
	IVertex* iVertex = NULL;
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex);

	iVertex->GetNormalCount(&m_NormalCount);

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN_CUR_NORMAL);

	if( m_nBrowseVertexAll == 0 )
	{
		pSpin->SetRange(0, m_NormalCount-1);
	}
	else
	{
		// In  case when browsing only vertexes for the cur simplex
		// show only normals which are used by the simplex
		pSpin->SetRange(m_nNormal, m_nNormal);
		pSpin->SetPos(m_nNormal);
	}

	m_spinNormalCount.SetRange(1, m_NormalCount);
	m_spinNormalCount.SetPos(m_NormalCount);

	// Only one normal is related to a simplex
	pSpin->EnableWindow( m_nBrowseVertexAll == 0 );

	UpdateCurNormal();

	iVertex->Release();
}

void CMorphDlg::UpdateVertexGroup()
{
	// For simplex all in loop. No head or tail. 
	bool bSimplex = m_nBrowseVertexAll == 1;

	GetDlgItem(IDC_BUT_PREV_VERT)->EnableWindow( bSimplex || m_CurVertex!=m_VertexHead );
	GetDlgItem(IDC_BUT_NEXT_VERT)->EnableWindow( bSimplex || m_CurVertex!=m_VertexTail );

	UpdateData(FALSE);
}

void CMorphDlg::OnClientDraw() 
{
	m_iDraw->PushAttrib();	// Save all attributes: current color, 
								// point size, and line width will be changed in this case

	// Draw a single point at the current vertex.
	m_iDraw->Color(1.0, 0.0, 0.0, 1.0);	// Set red  the current color (RGB and transparency)

	m_iDraw->PointSize(8);	

	// At this point the current drawing frame coinsides with the global axes
	// because we did not use IDraw.Translate, etc
	// To make it simpler and avoid drawing frame positioning
	// use global coordinates
	m_iDraw->Begin( ePoints );
		m_iDraw->Vertex(m_vtxGlob.x[0], m_vtxGlob.x[1], m_vtxGlob.x[2]);
	m_iDraw->End();

	// Draw the current simplex
	if( m_CurSimplex != 0 && m_iMesh )
	{
		INT_PTR v[3];

		m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

		DIPoint pt;

		m_iDraw->Color(0.7, 0.4, 1.0, 1.0);	
		m_iDraw->LineWidth( 3.0f );

		m_iDraw->Begin( eLineLoop );

			for( int i=0; i<3; i++)
			{
				pt = GetVertexGlob( v[i] );

				m_iDraw->Vertex( pt.x[0], pt.x[1], pt.x[2] );
			}

		m_iDraw->End();
	}
	
	// Draw the current normal
	m_iDraw->LineWidth( 2.0f );
	m_iDraw->Color( 0.4, 0.7, 0.0, 1.0 );	

	m_iDraw->Begin( eLines );

		m_iDraw->Vertex( m_vtxGlob.x[0], m_vtxGlob.x[1], m_vtxGlob.x[2] );
		m_iDraw->Vertex( 
				m_vtxGlob.x[0] + m_dNormalLength*m_dNormalX, 
				m_vtxGlob.x[1] + m_dNormalLength*m_dNormalY, 
				m_vtxGlob.x[2] + m_dNormalLength*m_dNormalZ );

	m_iDraw->End();

	m_iDraw->PopAttrib();	// Restore original attributes
}


void CMorphDlg::UpdatePage()
{
	EnableControls();

	if( m_iCurObject == NULL )
	{
		GetDlgItem(IDC_TXT_CUR_OBJECT)->SetWindowText("No selection");
		return;
	}

	UpdateSimplexButtons();

	char cObjName[100];

	m_iCurObject->GetName(cObjName);

	if( strlen( cObjName ) > 0 )
		GetDlgItem(IDC_TXT_CUR_OBJECT)->SetWindowText(cObjName);
	else
		GetDlgItem(IDC_TXT_CUR_OBJECT)->SetWindowText("No name");

	UpdateData(FALSE);
}


// In case there is no current object selected
// all controls except the bottom ones should
// be disabled
void CMorphDlg::EnableControls()
{
	BOOL bEnable = m_iCurObject != NULL;

	//Enable/disable all in a loop and enable 
	// bottom ones manually
	CWnd* pControl = GetWindow( GW_CHILD );

	// below casing firrst-chance exception on KC. KC is the last in tab order. So stop when reached
	while (pControl && pControl != &m_kernelCAD )
	{
		pControl->EnableWindow(bEnable);
		pControl = pControl->GetNextWindow(GW_HWNDNEXT);
	}

	GetDlgItem(IDC_GROUP_RENDER)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_MESH)->EnableWindow(TRUE);
	GetDlgItem(IDC_RADIO_SURFACE)->EnableWindow(TRUE);
	GetDlgItem(IDC_LABEL_CUR_OBJECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_TXT_CUR_OBJECT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_CHANGE_CUR_OBJ)->EnableWindow(TRUE);

	CButton* pRadioSurf = (CButton*)GetDlgItem(IDC_RADIO_SURFACE);
	int nCheck = pRadioSurf->GetCheck();
	GetDlgItem(IDC_SHADING)->EnableWindow( nCheck == 1 );
}


void CMorphDlg::UpdateCurNormal()
{
	IVertex* iVertex = NULL;
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex);

	iVertex->GetNormal(m_nCurNormal, &m_dNormalX, &m_dNormalY, &m_dNormalZ );

	iVertex->Release();
}


void CMorphDlg::OnFileExit() 
{
	EndDialog(IDOK);
}


void CMorphDlg::OnNextVertex() 
{
	if( m_CurVertex == 0 )
		return;	

	if( m_nBrowseVertexAll == 0 )
		m_iVertexIterator->GetNext(&m_CurVertex);
	else
	{
		if( ++m_curCorner >= 3 )
			m_curCorner = 0;	// Looping

		SetCurrentVertex( m_curCorner );
	}

	UpdateVertexInfo();
}


void CMorphDlg::OnPrevVertex() 
{
	if( m_CurVertex == 0 )
		return;	// Should not actually happen. In this case the button shuld be disabled

	if( m_nBrowseVertexAll == 0 )
		m_iVertexIterator->GetPrev(&m_CurVertex);
	else
	{
		if( --m_curCorner < 0 )
			m_curCorner = 2;	// Looping

		SetCurrentVertex( m_curCorner );
	}

	UpdateVertexInfo();
}

void CMorphDlg::OnNextSimplex() 
{
	if( m_CurSimplex == 0 ) return;
	m_iSimplexIterator->GetNext(&m_CurSimplex);
	UpdateSimplexInfo() ;
}

// Position of the current simplex m_CurSimplex has been modified. Update relevamt information
void CMorphDlg::UpdateSimplexInfo()
{
	UpdateSimplexButtons();

	if( m_nBrowseVertexAll == 1 )
		UpdateVertexInfo();
	else
		UpdateDisplay();
}

void CMorphDlg::OnPrevSimplex() 
{
	if( m_CurSimplex == 0 ) return;

	m_iSimplexIterator->GetPrev(&m_CurSimplex);
	UpdateSimplexButtons();
	
	if( m_nBrowseVertexAll == 1 )
		UpdateVertexInfo();
	else
		UpdateDisplay();
}

void CMorphDlg::UpdateSimplexButtons()
{
	GetDlgItem(IDC_BUT_NEXT_SIMPL)->EnableWindow( m_CurSimplex != m_SimplexTail );
	GetDlgItem(IDC_BUT_PREV_SIMPL)->EnableWindow( m_CurSimplex != m_SimplexHead );

	int buttons[] = {IDC_BUT_SIMPL_NEIGHBOUR_0, IDC_BUT_SIMPL_NEIGHBOUR_1, IDC_BUT_SIMPL_NEIGHBOUR_2};
	for(int i=0; i<3; i++)
	{
		ISimplexT* iSimpl = GetAdjacentSimplex(i);
		GetDlgItem( buttons[i] )->EnableWindow( iSimpl != NULL );
		RELEASE(iSimpl)
	}

	GetDlgItem( IDC_BUT_STAR_PREV )->EnableWindow( CanAdvanceSimplexInVertexStar(false) );
	GetDlgItem( IDC_BUT_STAR_NEXT )->EnableWindow( CanAdvanceSimplexInVertexStar(true) );
}

void CMorphDlg::OnVertexModify() 
{
	UpdateData();

	IMeshModsT* iMeshMods = NULL;

	m_iMesh->QueryInterface(IID_IMeshModsT, (void**)&iMeshMods);

	iMeshMods->SetVertexCoord(m_CurVertex, m_dVertexX, m_dVertexY, m_dVertexZ );

	// Update global coords for drawing
	m_vtxGlob = GetVertexGlob(m_CurVertex);

	// In v5 need to call Update()
	m_iModel->Update();
	m_kernelCAD.UpdateView();
	iMeshMods->Release();
}


void CMorphDlg::OnNormalModify() 
{
	UpdateData();

	IVertex* iVertex = NULL;
	
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex);

	iVertex->SetNormal(m_nCurNormal, m_dNormalX, m_dNormalY, m_dNormalZ );

	//Mark the object as modified. Required since v5.0
	IItem* item = NULL;
	m_iCurObject->QueryInterface(IID_IItem, (void**)&item);
	item->SetModified();

	UpdateDisplay();

	item->Release();
	iVertex->Release();
}


void CMorphDlg::OnDeltaposCurNormal(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;

	if(pNMUpDown->iDelta==0) return;

	m_nCurNormal += pNMUpDown->iDelta;

	if( m_nCurNormal < 0 )
	{
		m_nCurNormal = 0;
		*pResult = 1;	// Reject the change in the control
		return;
	}

	if( m_nCurNormal >= m_NormalCount )
	{
		m_nCurNormal = m_NormalCount-1;
		*pResult = 1;	// Reject the change in the control
		return;
	}

	OnCurNormalChanged();
	
	*pResult = 0;
}

void CMorphDlg::OnKillfocusEditCurNormal() 
{
	UpdateData();
	OnCurNormalChanged();
}

void CMorphDlg::OnCurNormalChanged()
{
	UpdateCurNormal();	
	UpdateData(FALSE);
	UpdateDisplay();
}

void CMorphDlg::OnRenderMesh() 
{
	m_kernelCAD.SetRenderSolid(FALSE);
	UpdatePage();
}

void CMorphDlg::OnRenderSurface() 
{
	m_kernelCAD.SetRenderSolid(TRUE);
	UpdatePage();
}

void CMorphDlg::OnChangeCurObject() 
{
	// Prompt the user to select an object with the mouse
	GetDlgItem(IDC_TXT_PROMPT)->ShowWindow(TRUE);

	// Switch to render surface to see the selected object
	// (Highlighted with reddish color)
	if( !m_kernelCAD.GetRenderSolid())
	{
		m_kernelCAD.SetRenderSolid(TRUE);

		CButton* pRadioSurf = (CButton*)GetDlgItem(IDC_RADIO_SURFACE);
		
		pRadioSurf->SetCheck(1);
	}

	// Change view mode to modal to enable mouse object selection
	IViewModal* iViewModal = NULL;

	m_iView->QueryInterface(IID_IViewModal, (void**)&iViewModal);

	iViewModal->SetViewMode( (int)eViewModeModify );

	iViewModal->Release();
}



void CMorphDlg::OnCurrentObjectChanged(LPUNKNOWN ppISectCur) 
{
	// Hide the prompt
	GetDlgItem(IDC_TXT_PROMPT)->ShowWindow(FALSE);

	// ISection of newly selected object is passed via parameter
	// Note: It can be NULL if user clicked outside any objects
	ISection* iNewObject = NULL;

	// ppISectCur = NULL is a valid case, which means that the user
	// clicked in 3D outside of any objects
	if( ppISectCur )
		ppISectCur->QueryInterface(IID_ISection, (void**)&iNewObject);
	
	if( m_iCurObject != iNewObject )	// The same object selected?
	{		
		// SOR sections do not have mesh
		char cType[30];	cType[0] = 0;

		// SOR sections do not have mesh
		if(iNewObject)
			iNewObject->GetSectionType(cType);

		if( iNewObject == NULL || strcmp(cType, "SORSection" ) == 0 )
		{
			if( iNewObject != NULL )
				AfxMessageBox("Surface Of Revolution objects do not have mesh\nPlease select another object");
			else
				AfxMessageBox("Nothing selected");

			// Restore current object in the model
			IModel2* iModel2 = NULL;
			m_iModel->QueryInterface( IID_IModel2, (void**)&iModel2 );

			iModel2->SetCurrentObject(m_iCurObject);

			RELEASE(iModel2);
		}
		else
		{
			m_iCurObject = iNewObject;
			UpdateObjectInfo();
		}
	}

	// Switch off modal mode right away to prevent moving objects
	// and enable viewing rotations, etc.
	IViewModal* iViewModal = NULL;
	m_iView->QueryInterface( IID_IViewModal, (void**)&iViewModal );

	iViewModal->SetViewMode( (int)eViewModeView );

	RELEASE(iViewModal);
}

void CMorphDlg::OnFileSaveas() 
{
	CString strModelPath = m_kernelCAD.GetModelPath();

	CFileDialog dlg( FALSE, "glm", strModelPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			"Model Files (*.glm)|*.glm||");

	if(dlg.DoModal() != IDOK)
		return;

	strModelPath = dlg.GetPathName();

	m_kernelCAD.SaveAs(strModelPath);
}


void CMorphDlg::OnFileOpen() 
{
	CString strModelPath = m_kernelCAD.GetModelPath();

	CFileDialog dlg( TRUE, "glm", strModelPath, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			"Model Files (*.glm)|*.glm||");

	if(dlg.DoModal() != IDOK)
		return;

	m_bShadingDataOK = false;

	strModelPath = dlg.GetPathName();	

	m_kernelCAD.SetModelPath(strModelPath);

	m_nBrowseVertexAll = 0;

	UpdateModelInfo();

	UpdateDisplay();
}


void CMorphDlg::OnDestroy() 
{
	ReleaseAll();

	CDialog::OnDestroy();
}


void CMorphDlg::ReleaseAll()
{
	// Defined in Samples\VC\Include\DITypes.h
	RELEASE(m_iDraw)
	RELEASE(m_iView)
	RELEASE(m_iFrameEx)
	RELEASE(m_iSimplexIterator)
	RELEASE(m_iVertexIterator)
	RELEASE(m_iMeshEx)
	RELEASE(m_iMesh)
	RELEASE(m_iCurObject)
	RELEASE(m_iModel)

	ASSERT(_CrtCheckMemory());
}


void CMorphDlg::OnSimplexDelete() 
{
	DeleteCurSimplex();
}


void CMorphDlg::OnSimplexDivide() 
{
	if( m_CurSimplex == 0 )
		return;

	IMeshTopolT* iMeshTopol = NULL;

	m_iCurObject->QueryInterface(IID_IMeshTopolT, (void**)&iMeshTopol);

	// Add a new vertex in the middle of the triangle
	INT_PTR posnVtx = 0;
	
	iMeshTopol->AddVertex(&posnVtx);

	INT_PTR v[3];
	// Calculate point in the middle as an average
	m_iMesh->GetSimplexVertices(m_CurSimplex, v, v+1, v+2);

	double corner[3][3];
	double vtx[3];

	vtx[0] = vtx[1] = vtx[2] = 0;

	for( int i=0; i<3; i++)
	{
		m_iMesh->GetVertexCoord( v[i], corner[i], corner[i]+1, corner[i]+2 );

		for( int k=0; k<3; k++)
			vtx[k] += corner[i][k]/3.0;
	}

	IMeshModsT* iMeshMods = NULL;

	m_iMesh->QueryInterface(IID_IMeshModsT, (void**)&iMeshMods);
	
	iMeshMods->SetVertexCoord( posnVtx, vtx[0], vtx[1], vtx[2] );

	// Need to set correct normal
	double n[3];
	ISimplexT* iSimplex = NULL;
	
	m_iMeshEx->GetSimplex(m_CurSimplex, &iSimplex);

	iSimplex->GetFacetNormal(n, n+1, n+2);

	iMeshMods->SetNormal(posnVtx, n[0], n[1], n[2]); //No sharp edges in the 
													// middle so the only normal in the vertex

	DeleteCurSimplex();

	// Replace the simplex
	iMeshTopol->AddSimplex( v[0], v[1], posnVtx, 90.0);
	iMeshTopol->AddSimplex( v[1], v[2], posnVtx, 90.0);
	iMeshTopol->AddSimplex( v[2], v[0], posnVtx, 90.0);

	m_iModel->Update();			// Required since v5.0 to propagate dirty flags from mesh to model

	// Need to update all intermediate members
	UpdateModelInfo();
}

void CMorphDlg::DeleteCurSimplex()
{
	if( m_CurSimplex == 0 ) return;

	// move current simplex position to a neighbour
	INT_PTR toDelete = m_CurSimplex;

	// Do the deletion
	IMeshTopolT* iMeshTopol = NULL;

	m_iMesh->QueryInterface(IID_IMeshTopolT, (void**)&iMeshTopol);
	
	iMeshTopol->RemoveSimplex(toDelete);

	UpdatePositions();

	UpdateSimplexButtons();

	m_iModel->Update();			// Required since v5.0 to propagate dirty flags from mesh to model

	UpdatePage();
	UpdateDisplay();

	iMeshTopol->Release();
}

void CMorphDlg::OnBrowseVertexAll() 
{
	m_nBrowseVertexAll = 0;
}

void CMorphDlg::OnBrowseVertexSimplex() 
{
	m_nBrowseVertexAll = 1;
}

void CMorphDlg::OnDeltaPosNormalCount(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);

	if(pNMUpDown->iDelta<=0)	
	{
		// Block Reduction - can crush the application. Need to take care about references in adjacent simplexes first
		*pResult = 1;	// Signal that the change has been refused
		return;
	}
	*pResult = 0;

	int count = pNMUpDown->iPos + pNMUpDown->iDelta;

	IVertex* iVertex = NULL;
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex);

	iVertex->SetNormalCount(count);

	UpdateNormalInfo();
	UpdateData(FALSE);

	iVertex->Release();
}

void CMorphDlg::OnVertexDelete()
{
	UpdateData();

	if( m_CurVertex == 0 ) return;

	if( AfxMessageBox("Delete Vertex operation should only be preformed\nto remove remaning isolated vertexes after\ndeletion of simplexes. Press Ok to proceede", MB_OKCANCEL ) != IDOK )
		return;

	// move current simplex position to a neighbour
	INT_PTR toDelete = m_CurVertex;

	// Do the deletion
	IMeshTopolT* iMeshTopol = NULL;

	m_iMesh->QueryInterface(IID_IMeshTopolT, (void**)&iMeshTopol);
	
	iMeshTopol->RemoveVertex(toDelete);

	UpdatePositions();

	UpdatePage();
	UpdateDisplay();

	iMeshTopol->Release();
}

void CMorphDlg::OnHelp()
{
	// DIHelp declaration is included via DIKernCAD.h in StdAfx.h
	DIHelp help("Samples/Morph.htm");
}

void CMorphDlg::SetSelectionMode(int mode)
{
	m_nSelectionMode = mode;
	GetDlgItem(IDC_MESSAGE_CLICK_SIMPLEX)->ShowWindow( mode >= 0 ? SW_SHOW : SW_HIDE );
	UpdateData(FALSE);	// Show / hide the IDC_MESSAGE_CLICK_SIMPLEX hint
}

void CMorphDlg::OnPickSimplex()
{
	SetSelectionMode(2);
}

void CMorphDlg::OnMouseDown(short Button, short Shift, long x, long y)
{
	if( m_nSelectionMode == 2 )
	{
		IView* iView = (IView*)m_kernelCAD.GetView();
	    
		IPick* iPick = NULL;
		iView->QueryInterface(IID_IPick, (void**)&iPick);

		ISurfacePointKC* surfPoint = NULL;
		iPick->GetSurfacePointAt( x, y, &surfPoint );

		IMeshPointKCT* iMeshPoint = NULL;
		surfPoint->QueryInterface(IID_IMeshPointKCT, (void**)&iMeshPoint);

		INT_PTR position = 0;
		iMeshPoint->GetSimplexPosition( &position );

		if( position != 0 )
		{
			m_CurSimplex = position;
			UpdateSimplexInfo();
		}

		RELEASE(iMeshPoint);
		RELEASE(surfPoint);
		iPick->Release();
		iView->Release();
		SetSelectionMode(-1);
	}
}

void CMorphDlg::OnSimplexGoToNeighbour0()
{
	GoToAdjacentSimplex(0);
}

void CMorphDlg::OnSimplexGoToNeighbour1()
{
	GoToAdjacentSimplex(1);
}

void CMorphDlg::OnSimplexGoToNeighbour2()
{
	GoToAdjacentSimplex(2);
}

ISimplexT* CMorphDlg::GetAdjacentSimplex(int edge)
{
	CHN(m_CurSimplex);
	ISimplexT* iSimplex = NULL;
	m_iMeshEx->GetSimplex(m_CurSimplex, &iSimplex);

	ISimplexEx_KCT* iSimplexEx = NULL;
	iSimplex->QueryInterface(IID_ISimplexEx_KCT, (void**)&iSimplexEx);		CHN(iSimplexEx);

	ISimplexEx_KCT* iSimplexExNeighbour = NULL;
	iSimplexEx->GetAdjacentSimplex(edge, &iSimplexExNeighbour );	

	ISimplexT* iSimplNeighBour = NULL;
	if( iSimplexExNeighbour )
	{
		iSimplexExNeighbour->QueryInterface(IID_ISimplexEx_KCT, (void**)&iSimplNeighBour);		CHN(iSimplexEx);
	}

	RELEASE(iSimplexExNeighbour);
	iSimplexEx->Release();
	iSimplex->Release();
	return 	iSimplNeighBour;
}

void CMorphDlg::GoToAdjacentSimplex(int edge)
{
	ISimplexT* iSimplNeighBour = GetAdjacentSimplex(edge);

	CH(iSimplNeighBour);		// Normally not an error. Happens when the edge is edge of th emesh
	// But in this application this means that the buttons where not disabled correctly

	m_iMeshEx->GetSimplexPosition(iSimplNeighBour, &m_CurSimplex);

	UpdateSimplexInfo();

	iSimplNeighBour->Release();
}

void CMorphDlg::OnPrevStarSimplex()
{
	AdvanceCurrentSimplexInVertexStar(false);
}

// If the current simplex does not belong to the start of the current vertex. Simplex 0 of the star
// is made current independently of bForward
void CMorphDlg::AdvanceCurrentSimplexInVertexStar(bool bForward)
{
	IVertex* iVertex = NULL;
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex );

	IVertexEx_KCT* iVertexEx = NULL;
	iVertex->QueryInterface(IID_IVertexEx_KCT, (void**)&iVertexEx);		CH(iVertexEx);

	// Get index of the the current simplex in star of the vertex
	ISimplexT* iSimplex = NULL;
	m_iMeshEx->GetSimplex(m_CurSimplex, &iSimplex);

	IObject_KC* iObject = NULL;
	iSimplex->QueryInterface(IID_IObject_KC, (void**)&iObject);		CH(iObject);

	int index = -1;
	iVertexEx->FindStarElement(iObject, &index );		// index is negative if did not find

	int indexNew = 0;	//If index < 0 assume the simplex was not in the star. Take th efist simplex

	if( index >= 0 )
	{
		int simplexCount = 0;
		iVertexEx->GetStarElementCount(2, &simplexCount);

		VARIANT_BOOL interior;
		iVertexEx->IsInteriorVertex(&interior);

		if( interior == VARIANT_FALSE )
		{
			// Case the vertex on edge of the mesh simplexes 0 and simplexCount-1 are on the edge of the mesh. Can not step beyond
			if( bForward && index >= simplexCount-1 || (index==0 && !bForward) )
				return;
		}

		// Get next cyclic
		if(bForward)
			indexNew = (index+1) % simplexCount;
		else
			indexNew = ( index==0 ? simplexCount-1 : index-1 );
	}

	ISimplexEx_KCT* iSimplexExNew = NULL;
	iVertexEx->GetStarSimplex( indexNew, &iSimplexExNew );
	ISimplexT* iSimplexNew = NULL;
	iSimplexExNew->QueryInterface(IID_ISimplexT, (void**)&iSimplexNew);

	m_iMeshEx->GetSimplexPosition(iSimplexNew, &m_CurSimplex);

	UpdateSimplexInfo();

	iSimplexExNew->Release();
	iSimplexNew->Release();
	iObject->Release();
	iSimplex->Release();
	iVertexEx->Release();
	iVertex->Release();
}

// Can do AdvanceCurrentSimplexInVertexStar(bool bForward) ?
bool CMorphDlg::CanAdvanceSimplexInVertexStar(bool bForward)
{
	IVertex* iVertex = NULL;
	m_iMeshEx->GetVertex(m_CurVertex, &iVertex );

	IVertexEx_KCT* iVertexEx = NULL;
	iVertex->QueryInterface(IID_IVertexEx_KCT, (void**)&iVertexEx);		CHN(iVertexEx);

	// Get index of the the current simplex in star of the vertex
	ISimplexT* iSimplex = NULL;
	m_iMeshEx->GetSimplex(m_CurSimplex, &iSimplex);

	IObject_KC* iObject = NULL;
	iSimplex->QueryInterface(IID_IObject_KC, (void**)&iObject);		CHN(iObject);

	int index = -1;
	iVertexEx->FindStarElement(iObject, &index );		// index is negative if did not find

	bool bOK = true;

	if( index >= 0 )
	{
		int simplexCount = 0;
		iVertexEx->GetStarElementCount(2, &simplexCount);

		VARIANT_BOOL interior;
		iVertexEx->IsInteriorVertex(&interior);

		if( interior == VARIANT_FALSE )
		{
			// Case the vertex on edge of the mesh simplexes 0 and simplexCount-1 are on the edge of the mesh. Can not step beyond
			if( bForward && index >= simplexCount-1 || (index==0 && !bForward) )
				bOK = false;
		}
	}

	iObject->Release();
	iSimplex->Release();
	iVertexEx->Release();
	iVertex->Release();
	return bOK;
}

void CMorphDlg::OnNextStarSimplex()
{
	AdvanceCurrentSimplexInVertexStar(true);
}

void CMorphDlg::OnShading()
{
	CH(m_iMesh);	CH(m_iCurObject);
	UpdateData();	// Get new m_bShading from check box

	IMeshShading_KCT* iMeshSahding = NULL;

	m_iMesh->QueryInterface(IID_IMeshShading_KCT, (void**)&iMeshSahding);		CH(iMeshSahding);

	iMeshSahding->SetShadingType( m_bShading ? 1 : 0 );

	if( m_bShading )
	{
		// Shading is not visible wwhen the object is current (highlighted)
		IModel2* iModel2 = NULL;
		m_iModel->QueryInterface(IID_IModel2, (void**)&iModel2);
		iModel2->SetCurrentObject(NULL);
		iModel2->Release();

		if (!m_bShadingDataOK)
		{
			// Define the colors once using coordinates. i-th component of color of a vertex is its i-th coordinate
			// mapped to required range
			IIteratorT* iVertexIterator;
			m_iMesh->GetVertexIterator(&iVertexIterator);
			INT_PTR posnVertex = 0;
			iVertexIterator->GetHeadPosition(&posnVertex);

			// Get dimensions of the object to scale colors properly
			IMetricsT* iMetr = NULL;
			m_iCurObject->QueryInterface(IID_IMetricsT, (void**)&iMetr);
			DIPoint min,max;
			iMetr->GetDimensions( &min, &max );
			double w[3], dw[3];
			for(BYTE i=0; i<3; i++)
				dw[i] = __max(max.x[i] - min.x[i], 1);	// Make sure not zero

			byte color[3];	// Integers in range 0 to 255

			while(posnVertex)
			{
				m_iMesh->GetVertexCoord(posnVertex, w, w+1, w+2 );
				// Color by coordinate:
				// Map min, max range to range of byte [0. 255] and take value of coordinate in this mapping
				for(BYTE i=0; i<3; i++)
					color[i] = (byte) (255 * ( ( w[i] - min.x[i] ) / dw[i] ) );

				iMeshSahding->SetVertexColor(posnVertex, color[0], color[1], color[2], 255 );	// 255 - completely opaque
				iVertexIterator->GetNext(&posnVertex);				// Move to the next
			}
			iMetr->Release();	iVertexIterator->Release();
			m_bShadingDataOK = true;
		}
	}

	ForceUpdatePresentationOf(m_iCurObject);

	m_kernelCAD.UpdateView();

	iMeshSahding->Release();
}

// Change in shading requres recalculation of presentation (generation of a relevant structure for renderer ) for the object
// Shading is a mesh attribute, which has no reference to the higher level section or model object. To force the recalcylation
// we make dirty resolution (not really used for mesh sections)
void CMorphDlg::ForceUpdatePresentationOf(ISection* object)
{
	CH(object);
	int res = 0;
	object->GetGeomResolution(&res);
	object->SetGeomResolution(res+1);
	object->SetGeomResolution(res);		// Restore. Not really needed. Just an example for parametric objects
}
