// MorphDlg.h : header file
//
//{{AFX_INCLUDES()
#include "kernelcad.h"
//}}AFX_INCLUDES

#if !defined(AFX_MORPHDLG_H__298CBE33_5768_4943_A06B_08A39DA2E44D__INCLUDED_)
#define AFX_MORPHDLG_H__298CBE33_5768_4943_A06B_08A39DA2E44D__INCLUDED_

#include "..\Include\DIError.h"
#include "..\Include\DIInterface.h"
#include "..\Include\DITypes.h"
#include "afxcmn.h"


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMorphDlg dialog

class CMorphDlg : public CDialog
{
// Construction
public:
	void ForceUpdatePresentationOf(ISection* object);
	bool CanAdvanceSimplexInVertexStar(bool bForward);
	void AdvanceCurrentSimplexInVertexStar(bool bForward);
	ISimplexT* GetAdjacentSimplex(int edge);
	void SetSelectionMode(int mode);
	void GoToAdjacentSimplex(int edge);
	void UpdateSimplexInfo();
	void DeleteCurSimplex();
	void ReleaseAll();
	void OnCurNormalChanged();
	void UpdateSimplexButtons();
	void UpdateCurNormal();
	void EnableControls();
	void UpdatePage();
	void UpdateVertexGroup();
	void UpdateNormalInfo();
	int FindCorner(INT_PTR vertex);
	DIPoint GetVertexGlob(INT_PTR vertex);
	void CalcModelSize();
	void UpdateVertexInfo();
	void SetCurrentVertex(int i);
	void UpdatePositions();
	void UpdateObjectInfo();
	void UpdateDisplay();
	ISection* CreateDefaultObject();
	void SetupView();
	void UpdateModelInfo();
	void CreateDefault();
	CMorphDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMorphDlg)
	enum { IDD = IDD_MORPH_DIALOG };
	CKernelCAD	m_kernelCAD;
	int		m_nBrowseVertexAll;
	double	m_dVertexX;
	double	m_dVertexY;
	double	m_dVertexZ;
	int		m_NormalCount;
	double	m_dNormalX;
	double	m_dNormalZ;
	double	m_dNormalY;
	INT_PTR		m_VertexCount;
	INT_PTR		m_SimplexCount;
	int		m_nCurNormal;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMorphDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	IModel* m_iModel;
	ISection* m_iCurObject;
	IMeshT* m_iMesh;
	IIteratorT* m_iVertexIterator;
	IIteratorT* m_iSimplexIterator;
	IMeshExT* m_iMeshEx;
	IFrameEx* m_iFrameEx;
	IView* m_iView;
	IDraw* m_iDraw;	// Interface for drawing in OnClientDraw()

	INT_PTR m_CurVertex;
	INT_PTR m_VertexHead;
	INT_PTR m_VertexTail;

	INT_PTR m_CurSimplex;
	INT_PTR m_SimplexHead;
	INT_PTR m_SimplexTail;

	DIPoint m_vtxGlob;	// The current vertex in globals axes

	double m_dNormalLength;	// For drawing normals

	int m_curCorner;	// In the current simplex
	int m_nNormal;	// At the m_curCorner, which used by the current simplex

	int m_nSelectionMode;	// -1 - idle (not in selection mode, default), 2 - select simplexes, 3 - select objects

	BOOL m_bShading;
	bool m_bShadingDataOK = false;

	// Generated message map functions
	//{{AFX_MSG(CMorphDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClientDraw();
	afx_msg void OnFileExit();
	afx_msg void OnNextVertex();
	afx_msg void OnPrevVertex();
	afx_msg void OnNextSimplex();
	afx_msg void OnPrevSimplex();
	afx_msg void OnVertexModify();
	afx_msg void OnNormalModify();
	afx_msg void OnDeltaposCurNormal(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusEditCurNormal();
	afx_msg void OnRenderMesh();
	afx_msg void OnRenderSurface();
	afx_msg void OnChangeCurObject();
	afx_msg void OnCurrentObjectChanged(LPUNKNOWN ppISectCur);
	afx_msg void OnFileSaveas();
	afx_msg void OnFileOpen();
	afx_msg void OnDestroy();
	afx_msg void OnSimplexDelete();
	afx_msg void OnSimplexDivide();
	afx_msg void OnBrowseVertexAll();
	afx_msg void OnBrowseVertexSimplex();
	afx_msg void OnVertexDelete();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnDeltaPosNormalCount(NMHDR *pNMHDR, LRESULT *pResult);
public:
	CSpinButtonCtrl m_spinNormalCount;
	afx_msg void OnHelp();
	afx_msg void OnPickSimplex();
	void OnMouseDown(short Button, short Shift, long x, long y);
	afx_msg void OnSimplexGoToNeighbour0();
	afx_msg void OnSimplexGoToNeighbour1();
	afx_msg void OnSimplexGoToNeighbour2();
	afx_msg void OnPrevStarSimplex();
	afx_msg void OnNextStarSimplex();
	afx_msg void OnShading();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MORPHDLG_H__298CBE33_5768_4943_A06B_08A39DA2E44D__INCLUDED_)
